2

我最近在我的一个 Bash 脚本中遇到了一个问题,这是由它运行的一个 SSH 命令的意外输出引起的(由于操作系统版本升级)。这个问题实际上导致了 Bash 语法错误,因为我希望这个输出只包含一个数字状态代码(来自远程脚本),然后我在算术表达式中使用了它。

不过,令我惊讶的是,我的 Bash 脚本在报告语法错误后继续执行。尽管事实上我在文件开头附近有以下行:

# Terminate script if any command fails
set -o errexit

尽管语法错误显然与失败的命令不同,但在我看来,前者代表了更严重的错误情况。

我知道您可以使用 -n 参数来检查 Bash 脚本的语法,而无需实际执行任何命令,但无论如何也不会遇到这个问题。

这是一个导致错误但不退出的示例:

#!/bin/bash
set -o errexit
x=")"
echo $(( x + 1 ))
echo still running

在正常操作期间检测到算术表达式中的语法错误后,有什么方法可以强制 Bash 脚本立即终止?

4

1 回答 1

1

快速的答案是,在这种情况下,您可以通过检查来捕获它$?

#!/bin/bash
x=")"
echo $(( $x + 1 ))
if [[ $? != 0 ]]; then
    echo >&2 "caught syntax error; aborting"
    exit $?
fi
echo success

但是,这种方法并不总是有效,例如

#!/bin/bash
x="-1"
(( x += 1 ))
if [[ $? != 0 ]]; then
    echo >&2 "caught syntax error; aborting"
    exit $?
fi
echo success

将导致:

caught syntax error; aborting

bash(1)手册页说:

The evaluation is performed according to the rules listed below
under ARITHMETIC EVALUATION.  If expression is invalid, bash
prints a message indicating failure and no substitution occurs.

但这隐藏了 Bash 在语法错误方面相当特殊的行为的一些细节。例如,

#!/bin/bash
x=")"
if echo $(( $x + 1 )); then
    echo success
else
    echo failure
fi; echo "almost end of script"
echo "end of script"

结果是:

./foo.sh: line 3: ) + 1 : syntax error: operand expected (error token is ") + 1 ")
end of script

顺便说一句,set -o errexit这似乎没有任何区别。

于 2013-03-10T22:20:43.243 回答